

#define VIA_1	$30f
#define VIA_2	$30c


_Counter	.byt	30




_PlayDigit
	lda	#30	; 47
	sta	_Counter

	lda	#$07
	ldx	#$ff
	jsr	$f590


	lda	#<(_Sample)
	sta	adr_samp+1
	lda	#>(_Sample)
	sta	adr_samp+2

	ldx	#$CC
	sei
playnote_loop

adr_samp
	ldy	_Sample


	lda	#8
	sta	VIA_1

	lda	#$EE
	sta	VIA_2
	stx	VIA_2

	lda	table_1,y
	sta	VIA_1

	lda	#$EC
	sta	VIA_2
	stx	VIA_2




	lda	#9
	sta	VIA_1

	lda	#$EE
	sta	VIA_2
	stx	VIA_2

	lda	table_2,y
	sta	VIA_1

	lda	#$EC
	sta	VIA_2
	stx	VIA_2




	lda	#10
	sta	VIA_1

	lda	#$EE
	sta	VIA_2
	stx	VIA_2

	lda	table_3,y
	sta	VIA_1

	lda	#$EC
	sta	VIA_2
	stx	VIA_2


	nop
	nop
	nop
	nop
	nop
	nop
	nop


	inc	adr_samp+1
	bne	playnote_loop

	inc	adr_samp+2
	dec	_Counter
	bne	playnote_loop

	cli
	;jmp	 _PlayDigit
	rts



;
; A -> Numro de registre SoundChip (0-13)
; X -> Valeur  crire
;
VIA_select
	sta	VIA_1
	txa

	pha
	lda	VIA_2
	ora	#$EE		; $EE	238	11101110
	sta	VIA_2

	and	#$11		; $11	17	00010001
	ora	#$CC		; $CC	204	11001100
	sta	VIA_2

	tax
	pla
	sta	VIA_1
	txa
	ora	#$EC		; $EC	236	11101100
	sta	VIA_2

	and	#$11		; $11	17	00010001
	ora	#$CC		; $CC	204	11001100
	sta	VIA_2
	rts



	;org $bb80
	;org $3000

	.dsb 256-(*&255)

table_1
	.byt	0,1,2,3,3,4,4,5
	.byt	5,5,6,6,6,6,6,6
	.byt	7,7,7,7,7,7,8,8
	.byt	8,8,8,8,8,8,8,9
	.byt	9,9,9,9,9,9,9,9
	.byt	9,9,9,$A,$A,$A,$A,$A
	.byt	$A,$A,$A,$A,$A,$A,$A,$A
	.byt	$A,$A,$A,$A,$A,$B,$B,$B
	.byt	$B,$B,$B,$B,$B,$B,$B,$B
	.byt	$B,$B,$B,$B,$B,$B,$B,$B
	.byt	$B,$B,$B,$B,$B,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C

	.dsb 256-(*&255)

table_2
	.byt	0,1,1,0,1,1,2,1
	.byt	2,2,1,2,2,3,4,4
	.byt	1,2,2,3,4,4,0,1
	.byt	2,3,3,4,4,5,5,1
	.byt	2,3,3,4,4,5,5,5
	.byt	6,6,6,1,2,2,3,3
	.byt	4,4,5,5,6,6,6,6
	.byt	6,6,7,7,7,1,2,2
	.byt	3,4,4,5,5,5,6,6
	.byt	6,6,6,6,7,7,7,7
	.byt	7,7,7,8,8,0,1,2
	.byt	3,3,4,4,5,5,5,6
	.byt	6,6,6,6,6,7,7,7
	.byt	7,7,7,8,8,8,8,8
	.byt	8,8,8,8,9,9,9,9
	.byt	9,9,9,9,9,9,9,9
	.byt	$A,$A,$A,$A,$A,$A,$A,$A
	.byt	$A,$A,$A,$A,$A,$A,$A,$A
	.byt	$A,$A,$B,$B,$B,$B,$B,$B
	.byt	$B,$B,$B,$B,$B,$B,$B,$B
	.byt	$B,$B,$B,$B,$B,$B,$B,$B
	.byt	$B,$B,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C

	.dsb 256-(*&255)

table_3
	.byt	0,1,1,0,2,1,1,0
	.byt	0,2,1,1,2,2,1,2
	.byt	1,1,2,2,1,2,0,2
	.byt	2,1,2,1,2,1,2,1
	.byt	1,0,2,1,2,1,2,3
	.byt	2,2,3,1,1,2,1,2
	.byt	2,2,2,2,1,2,3,3
	.byt	4,4,1,2,3,1,1,2
	.byt	2,1,2,0,2,3,1,2
	.byt	3,3,4,4,1,2,3,3
	.byt	4,4,5,2,2,0,2,2
	.byt	0,2,1,2,1,2,3,2
	.byt	2,3,4,4,5,2,2,3
	.byt	4,4,5,0,2,3,3,4
	.byt	4,5,5,6,2,2,3,4
	.byt	4,5,5,5,6,6,6,6
	.byt	1,2,3,3,4,4,5,5
	.byt	6,6,6,6,7,7,7,7
	.byt	7,7,2,2,3,4,4,5
	.byt	5,5,6,6,6,6,7,7
	.byt	7,7,7,7,8,8,8,8
	.byt	8,8,0,2,2,3,4,4
	.byt	5,5,6,6,6,6,6,7
	.byt	7,7,7,7,7,8,8,8
	.byt	8,8,8,8,8,9,9,9
	.byt	9,9,9,9,9,9,9,$A
	.byt	$A,$A,$A,$A,$A,$A,$A,$A
	.byt	$A,$A,$A,$A,$A,$A,$B,$B
	.byt	$B,$B,$B,$B,$B,$B,$B,$B
	.byt	$B,$B,$B,$B,$B,$B,$B,$B
	.byt	$B,$B,$B,$C,$C,$C,$C,$C
	.byt	$C,$C,$C,$C,$C,$C,$C,$C

