@ECHO OFF


::
:: Initial check.
:: Verify if the SDK is correctly configurated
::
IF "%OSDK%"=="" GOTO ErCfg


::
:: Set the build paremeters
::
CALL osdk_config.bat

::
:: Converting from WAV to RAW...
::
echo Converting from WAV to RAW...
.\tools\sox sample.wav -r 11025 -b -u -c1 Output.raw


:: Converting from RAW to AY
::
echo Converting from RAW to AY
.\tools\sam2ay.exe

%OSDK%\bin\bin2txt -s1 -f2 -n16 Output.ay sample.s _Sample

::
:: Launch the compilation of files
::
CALL %OSDK%\bin\make.bat %OSDKFILE%
GOTO End


::
:: Outputs an error message
::
:ErCfg
ECHO == ERROR ==
ECHO The Oric SDK was not configured properly
ECHO You should have a OSDK environment variable setted to the location of the SDK
IF "%OSDKBRIEF%"=="" PAUSE
GOTO End


:End
pause